<template>
  <div class="webcam">
    <div class="left-panel">
      <div class="images" v-for="item in imgArray" :key="item.id">
        <!-- <p class="exercise">{{item.name}}</p> -->
        <img :src="item.src" alt="workout" class="image" />
      </div>
        <div class="main-image">
          <img :src="mainImageSrc" />
        </div>
      <div class="timer">
        <p>{{seconds}} : {{countDown}}</p>
        <h2>seconds left to hold</h2>
      </div>
    </div>
    <div class="right-panel">
      <vue-p5 v-on="{setup,draw,keypressed}"></vue-p5>
      <p class="loading" v-if="isLoading">Loading...</p>
    </div>
  </div>
</template>
<script>
import VueP5 from "vue-p5";
import * as ml5 from "ml5";
// import ml5 from "../assets/script/ml5.min"
export default {
  name: "Webcam",
  components: {
    "vue-p5": VueP5
  },
  data() {
    return {
      video: "",
      poseNet: "",
      pose: "",
      skeleton: "",
      brain: {},
      state: "waiting",
      isLoading: true,
      targetLabel: "",
      seconds: "00",
      countDown: 20,
      // url: "https://teachablemachine.withgoogle.com/models/jynr2nEjS/",
      poseLabel: "",
      imgArray: [],
      mainImageSrc: null,
       currentIndex: 1
    };
  },
  methods: {
    setup(sketch) {
      sketch.createCanvas(640, 480);
      this.video = sketch.createCapture(sketch.VIDEO);
      this.video.hide();
      this.poseNet = ml5.poseNet(this.video, this.modelLoaded);
      this.poseNet.on("pose", this.gotPoses);
      let options = {
        inputs: 34,
        outputs: 4,
        task: "classification",
        debug: true
      };
      this.brain = ml5.neuralNetwork(options);
      const modelInfo = {
        model: "http://bot.issett.com/images/uploads/model.json",
        metadata: "http://bot.issett.com/images/uploads/model_meta.json",
        weights: "http://bot.issett.com/images/uploads/model.weights.bin"
      };
      this.brain.load(modelInfo, this.brainLoaded);
      // console.log(this.brain);
      // this.brain.loadData('../models/exercise.json',this.dataReady);
    },
    brainLoaded() {
      console.log("Classification is ready");
      this.classifyPose();
    },
    gotPoses(poses) {
      // console.log(poses);
      if (poses.length > 0) {
        this.pose = poses[0].pose;
        this.skeleton = poses[0].skeleton;
        if (this.state == "collecting") {
          let inputs = [];
          for (let i = 0; i < this.pose.keypoints.length; i++) {
            let x = this.pose.keypoints[i].position.x;
            let y = this.pose.keypoints[i].position.y;
            inputs.push(x);
            inputs.push(y);
          }
          let target = [this.targetLabel];
          this.brain.addData(inputs, target);
        }
      }
    },
    classifyPose() {
      if (this.pose) {
        var inputs = [];
        for (let i = 0; i < this.pose.keypoints.length; i++) {
          let x = this.pose.keypoints[i].position.x;
          let y = this.pose.keypoints[i].position.y;
          inputs.push(x);
          inputs.push(y);
        }
        this.brain.classify(inputs, this.gotResult);
      } else {
        console.log("Pose not found");
        setTimeout(this.classifyPose, 1000);
      }
    },
    gotResult(error, results) {
      if (results[0].confidence > 0.75) {
        this.poseLabel = results[0].label.toUpperCase();
      }
      // console.log(results[0].confidence);
      this.classifyPose();
    },
    countDownTimer() {
      if (this.countDown > 0) {
        setTimeout(() => {
          this.countDown -= 1;
          this.countDownTimer();
        }, 1000);
      } else {
        console.log("Shuffle");
      }
    },
    draw(sketch) {
      sketch.push();
      sketch.translate(this.video.width, 0);
      sketch.scale(-1, 1);
      sketch.image(this.video, 0, 0);
      if (this.pose) {
        // sketch.fill(255, 0, 0);
        // sketch.ellipse(this.pose.nose.x, this.pose.nose.y, 64);
        for (let i = 0; i < this.pose.keypoints.length; i++) {
          let x = this.pose.keypoints[i].position.x;
          let y = this.pose.keypoints[i].position.y;
          sketch.fill(0, 255, 0);
          sketch.ellipse(x, y, 16, 16);
        }
        for (let i = 0; i < this.skeleton.length; i++) {
          let a = this.skeleton[i][0];
          let b = this.skeleton[i][1];
          sketch.strokeWeight(2);
          sketch.stroke(255);
          sketch.line(a.position.x, a.position.y, b.position.x, b.position.y);
        }
      }
      sketch.pop();
      sketch.fill(255, 0, 255);
      sketch.noStroke();
      sketch.textSize(256);
      sketch.textAlign(sketch.CENTER, sketch.CENTER);
      sketch.text(this.poseLabel, sketch.width / 2, sketch.height / 2);
    },
    modelLoaded() {
      // this.countDownTimer();
      this.isLoading = false;
      console.log("Model is loaded");
    },
    // async modelInfo(){
    //   modelUrl = this.url + "model.json"
    // },
    keypressed(sketch) {
      if (sketch.key == "s") {
        this.brain.saveData();
      } else {
        this.targetLabel = sketch.key;
        console.log(this.targetLabel);
        setTimeout(() => {
          console.log("collecting");
          this.state = "collecting";
          setTimeout(() => {
            console.log("not collecting");
            this.state = "waiting";
          }, 10000);
        }, 10000);
      }
    },
    dataReady() {
      this.brain.normalizeData();
      this.brain.train({ epochs: 50 }, this.finished);
    },
    finished() {
      console.log("Model is trained");
      this.brain.save();
    },
    next(){
      this.currentIndex += 1;
    },
  },
  created() {
    let self = this;
    this.imgArray = [
      {
        id: "1",
        src: require("@/assets/Images/exercise/flexorstretchie.png"),
        name: "Leg Stretch"
      },
      {
        id: "2",
        src: require("@/assets/Images/exercise/armcircleie.png"),
        name: "Arm Circle"
      },
      {
        id: "3",
        src: require("../assets/Images/exercise/squat.png"),
        name: "Squat"
      },
      {
        id: "4",
        src: require("../assets/Images/exercise/sidestretch.png"),
        name: "Side Stretch"
      }
    ];
    setInterval(function() {
      self.mainImageSrc =
        self.imgArray[Math.abs((self.currentIndex) % self.imgArray.length)].src;
        self.next();
        self.countDownTimer();
    }, 20000);
  }
};
</script>

<style scoped>
* {
  margin: 0;
  padding: 0;
  box-sizing: border-box;
}
.webcam {
  position: relative;
  width: 100%;
  min-height: 100vh;
  padding: 0 100px;
  display: flex;
  justify-content: flex-start;
  align-items: center;
}
.webcam > .left-panel {
  position: relative;
  max-width: 550px;
}
.webcam > .left-panel > .images > .image{
display: none;
}
.webcam > .left-panel > .images > .exercise {
  font-size: 2.5em;
  font-weight: 700;
  position: absolute;
  color: #b383e0;
  transform: translate(-50%);
  left: 50%;
}
/* .webcam > .left-panel > .timer{
  margin-top:1.5rem;
} */
.webcam > .left-panel > .timer > p {
  display: flex;
  justify-content: center;
  font-size: 3em;
  color: #b383e0;
  font-weight: 700;
}
.webcam > .left-panel > .timer > h2 {
  text-align: center;
  color: #b283df;
}
.webcam > .left-panel > .timer > p {
  display: flex;
  justify-content: center;
  font-size: 3em;
  color: #b383e0;
  font-weight: 700;
}
.webcam > .left-panel > .timer > span {
  display: flex;
  justify-content: center;
  font-size: 3em;
  color: #b383e0;
  font-weight: 700;
}
.webcam > .right-panel {
  position: relative;
  background: #eaebe5;
  margin-left: 40px;
  width: 100%;
  height: 480px;
}
.webcam > .right-panel > .loading {
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  color: #ccc;
  font-size: 2.5em;
}
</style>